package nl.amis.rest.controller;

import java.util.ArrayList;
import java.util.Collection;

import nl.amis.rest.resources.Thing;
import nl.amis.rest.resources.ThingResource;
import nl.amis.rest.resources.ThingsResource;

import org.restlet.Application;
import org.restlet.Restlet;
import org.restlet.Router;


public class RestfulApplication extends Application {
    public RestfulApplication() {
        things.add(new Thing("FirstThing", "Wildlife in South America",
                             "American President", 2008, 42));
        things.add(new Thing("OneMoreThing", "Officer Orange",
                             "Sixteen Degrees", 8, 305));
    }

    private Collection<Thing> things = new ArrayList();

    /**
     * Creates a root Restlet that will receive all incoming calls.
     */
    @Override
    public synchronized Restlet createRoot() {
        // Create a router Restlet that defines routes.
        Router router = new Router(getContext());

        // Defines a route for the resource "list of items"
        router.attach("/things", ThingsResource.class);
        // Defines a route for the resource "item"
        router.attach("/things/{thingName}", ThingResource.class);

        return router;
    }

    public void setThings(Collection<Thing> things) {
        this.things = things;
    }

    public Collection<Thing> getThings() {
        return things;
    }
}
